<?php
/**
 * Created by PhpStorm.
 * User: Villa
 * Date: 03/12/2018
 * Time: 16:21
 */


trait Trait_InutraliaWS {

    public function save_token_credentials ($token_auth){
        \Session::set('token_auth',$token_auth);
    }

    public function get_header(){


        return array(
            'Content-Type: application/json',
            'Accept: application/json',
            'Authorization: Basic '. \Session::get('token_auth'),
        );

    }

    /**
     * Method to make requests to inutralia.
     *
     * MORE INFO CURL --> http://php.net/manual/es/function.curl-setopt.php
     *
     * @param $parameter_url
     * @param bool $header
     * @param int $timeout
     * @param bool $httpget
     * @param int $return_transfer
     * @return mixed
     */

    public function request_generic($url, $method = "get", $return_transfer = 1, $extra_options = array(),$add_params_header = array()){

        $constant = \Config::load('constants');

        // La url la obtiene de config dependiendo del entorno.
        $ch = curl_init($constant['domain'].$url.$constant['apikey']);

        curl_setopt($ch, CURLOPT_HTTPHEADER,array_merge($this->get_header(),$add_params_header));

        curl_setopt($ch, $method == "get" ? CURLOPT_HTTPGET :CURLOPT_POST , 1);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, $return_transfer);

        foreach ($extra_options as $key => $value){
            curl_setopt($ch, $key, $value);
        }


        $return = curl_exec($ch);

        curl_close($ch);

        return $return;
    }

    /**
     *
     * User auth basic request for login, save the user token in session for all requests.
     *
     * @param $user
     * @param $password
     */

    public function ws_user($user,$password){

        $this->save_token_credentials(base64_encode("$user:$password"));

        return json_decode($this->request_generic('user'));

    }

    /**
     * Reques profile get
     *
     * @param null $data
     * @return mixed
     */
    public function ws_profile_get(){

        return json_decode($this->request_generic('profile'));

    }

    /**
     * Reques profile put
     *
     * @param $data
     * @return mixed
     */
    public function ws_profile_put($id, $data){

        $data_json = http_build_query($data);

        $extra_options = array(
            CURLOPT_CUSTOMREQUEST => 'put',
            CURLOPT_POSTFIELDS => $data_json
        );

        return json_decode($this->request_generic('profile'.DS.$id,"post",1,$extra_options,array('Content-Length: ' . strlen($data_json))));

    }


}